<script lang="ts">
  import HeaderWithBackdrop from '$lib/components/ui-elements/HeaderWithBackdrop.svelte';
  import TeamTable from '../team-dashboard/TeamTable.svelte';
  import { TeamByPkStore } from '$houdini';
  import type { Team } from '$lib/graphql/types';
  import Spinner from '$lib/components/ui-elements/Spinner.svelte';
  import EventRegistration from '$lib/components/pages/team-dashboard/EventRegistration.svelte';
  import { goto } from '$app/navigation';
  import { archivedTeams } from '$routes/(app)/user-dashboard/stores';
  import { Alert } from 'flowbite-svelte';
  import WelcomeGuideAlert from '$lib/components/ui-elements/WelcomeGuideAlert.svelte';

  export let teamId: string;
  // todo handle invalid teamId without spinning forever
  $: teamStore = new TeamByPkStore();
  $: teamStore.subscribe((result) => {
    if (result.errors?.length) console.error('failed fetch', result.errors);
  });
  let team: Team;
  $: fetch(teamId);

  async function fetch(team_id: string) {
    await teamStore.fetch({ variables: { team_id } });
    // NOTE: must do this over `$: team = $teamStore.data?.teams_by_pk;`, otherwise nulls will appear 👻
    // typing override so that we can pass to TeamTable
    if ($teamStore.data) team = $teamStore.data.teams_by_pk as Team;
  }
</script>

{#if team?.future_events?.length}
  {#each team.future_events as { event }}
    <div class="pb-4">
      <WelcomeGuideAlert {event} />
    </div>
  {/each}
{/if}

<HeaderWithBackdrop size="sm" secondary>Team Roster</HeaderWithBackdrop>

<h1 class="text-2xl font-semibold text-cyber-blue-500 mt-10">Current Team Roster</h1>

<div class="w-full">
  <!--  <TeamTable hideControls={!team.roster_change_allowed} {team} {deleteTeam} {addMember} />-->
  {#if !team}
    <div class="w-full h-64">
      <div class="self-center mx-auto my-auto">
        <Spinner />
      </div>
    </div>
  {:else}
    <TeamTable on:delete={() => goto('/user-dashboard/teams')} on:refetch={() => fetch(teamId)} {team} />
  {/if}

  <!--{#if !team.roster_change_allowed}-->
  <!--  <div class="pt-2">-->
  <!--    <Alert color="orange">-->
  <!--      <div class="flex flex-row justify-center align-middle">-->
  <!--        Team modifications are now locked <Fa class="ml-2 mt-0.5" icon={faLock} />-->
  <!--      </div>-->
  <!--    </Alert>-->
  <!--  </div>-->
  <!--{/if}-->
</div>

<div class="my-5" />
<!-- We use $teamStore.fetching here as a hack to ensure
     the event checklists reload when a team is updated. -->
{#if !team || $teamStore.fetching}
  <div class="w-full h-64">
    <div class="self-center mx-auto my-auto">
      <Spinner />
    </div>
  </div>
  <!-- Hide event registration if team is archived -->
{:else if !$archivedTeams.map(t => t.id).includes(teamId)}
  <EventRegistration on:refetch={() => fetch(teamId)} {team} />
{/if}
